$ifndef _ERead_EWrite_inc_
$define _ERead_EWrite_inc_
'
' Replacement Eread and Ewrite library routines for use with the 16F18877 device
' 
$if _device <> _16F18877 
    $error "These rutines are only for the 16F18877 devcie" 
$endif 
    #disable ERead, EWrite                          ' Disable the compiler's eread and ewrite commands
    
    GoTo _EE_Main_                                  ' Jump over the routines

'---------------------------------------------------------
' Eread command library routine replacement for enhanced 14-bit core devices that contain the NVM SFRs And 256 bytes of eeprom
' Input     : WREG holds the address
' Output    : WREG holds the byte read from the eeprom
' Notes     : None
'
__EERead_:
    NVMADRL = WREG
__EERead_W_:
    Clear NVMCON1
    Set NVMCON1bits_RD
    WREG = NVMDATL
    Inc NVMADRL
    Return

'---------------------------------------------------------
' Ewrite command library routine replacement for enhanced 14-bit core devices that contain the NVM SFRs and 256 bytes of eeprom
' Input     : WREG holds the byte to write to the eeprom
' Output    : None
' Notes     : None
'    
__EEWrite_:
__EEWrite_W_:
    NVMDATL = WREG
    NVMCON1 = $04
    NVMCON2 = $55
    NVMCON2 = $AA
    Set NVMCON1bits_WR   
    Btfsc NVMCON1bits_WR
    Bra ($ - 1)
    Clear NVMCON1bits_WREN
    Inc NVMADRL
    Return
        
'---------------------------------------------------------------------------------- 
_EE_Main_:

$endif  ' _ERead_EWrite_inc_ 
    
    



